% !Mode:: "TeX:UTF-8"                                  %  采用UTF-8编码
%& -makeindex_opts='-C mixed -s ctex.ist'              %  索引按拼音排序
%%
%% This is file `snnupaper.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% nudtpaper.dtx  (with options: `cls')
%%
%% This is a generated file.
%%
%% Copyright (C) 2010 by Liu Benyuan <liubenyuan@gmail.com>
%%
%% This file may be distributed and/or modified under the
%% conditions of the LaTeX Project Public License, either version 1.3a
%% of this license or (at your option) any later version.
%% The latest version of this license is in:
%%
%% http://www.latex-project.org/lppl.txt
%%
%% and version 1.3a or later is part of all distributions of LaTeX
%% version 2004/10/01 or later.
%%
%% To produce the documentation run the original source files ending with `.dtx'
%% through LaTeX.
%%
%% Any Suggestions : LiuBenYuan <liubenyuan@gmail.com>
%% Thanks Xue Ruini <xueruini@gmail.com> for the thuthesis class!
%% Thanks sofoot for the original NUDT paper class!
%%
\NeedsTeXFormat{LaTeX2e}[1999/12/01]
\ProvidesClass{snnupaper}
[2011/05/23 v1.0 SNNU paper template]
\newif\ifismaster\ismastertrue
\newif\ifisttf\isttftrue
\DeclareOption{master}{\ismastertrue}
\DeclareOption{doctor}{\ismasterfalse}
\newif\ifisanon\isanonfalse
\DeclareOption{anon}{\isanontrue}
\newif\ifistwoside\istwosidefalse
\DeclareOption{twoside}{\istwosidetrue}
\DeclareOption{ttf}{\isttftrue}
\DeclareOption{otf}{\isttffalse}
\newif\ifisvista\isvistafalse
\DeclareOption{vista}{\isvistatrue}
\DeclareOption*{\PackageWarning{snnupaper}{Unknown Option '\CurrentOption'}}
\ProcessOptions\relax
\RequirePackage{ifthen,calc}
\ifistwoside
  \LoadClass[a4paper,12pt,openright,twoside]{book}
\else
  \LoadClass[a4paper,12pt,openany]{book}
\fi
\RequirePackage[includeheadfoot]{geometry}
\RequirePackage[center,pagestyles]{titlesec}
\RequirePackage{titletoc}
\RequirePackage{graphicx}
\RequirePackage[config]{subfig}
\RequirePackage{float}
\RequirePackage{array}
\RequirePackage{longtable}
\RequirePackage{booktabs}
\RequirePackage{multirow}
\RequirePackage{tabularx}
\RequirePackage{diagbox}
\RequirePackage[neverdecrease]{paralist}
\RequirePackage{xcolor}
\RequirePackage{amsmath,amssymb,bm}
\RequirePackage[varg]{txfonts}
\RequirePackage[amsmath,thmmarks,hyperref]{ntheorem}
%\RequirePackage[CJKnumber,CJKtextspaces,CJKmathspaces,no-math]{xeCJK}
\RequirePackage[CJKnumber,no-math]{xeCJK}
\RequirePackage{xeCJKfntef}                          %%% 下划线宏包 2011.05.2 yinjc
\RequirePackage{CJKnumb}
\RequirePackage{indentfirst}
\RequirePackage[numbers,sort&compress,square]{natbib}
\RequirePackage[CJKbookmarks=true,pdfborder=0 0 1]{hyperref}
\defaultfontfeatures{Mapping=tex-text}
\xeCJKsetcharclass{"0}{"2E7F}{0}
\xeCJKsetcharclass{"2E80}{"FFFF}{1}
\newcommand\installTTF{%
  \setmainfont{Times New Roman}
  \setsansfont{Arial}
  \setmonofont{Courier New}
  \ifisvista
    \setCJKmainfont[BoldFont={SimHei},ItalicFont={KaiTi}]{SimSun}
    \setCJKmonofont{KaiTi} % Pluto use LiSu Thu use Kaiti, orig is SimSun
    \setCJKfamilyfont{fs}{FangSong}
    \setCJKfamilyfont{kai}{KaiTi}
  \else
    \setCJKmainfont[BoldFont={SimHei},ItalicFont={KaiTi_GB2312}]{SimSun}
    \setCJKmonofont{KaiTi_GB2312} % Pluto use LiSu Thu use Kaiti, orig is SimSun
    \setCJKfamilyfont{fs}{FangSong_GB2312}
    \setCJKfamilyfont{kai}{KaiTi_GB2312}
  \fi
  \setCJKsansfont{SimHei}
  \setCJKfamilyfont{song}{SimSun}
  \setCJKfamilyfont{hei}{SimHei}
  \setCJKfamilyfont{li}{LiSu}
  \setCJKfamilyfont{you}{YouYuan}
}
\newcommand\installOTF{%
  \setmainfont{Times New Roman} % could be changed to "Times New Roman PS Std"
  \setsansfont{Arial}
  \setmonofont{Courier New}
  \setCJKmainfont[BoldFont={Adobe Heiti Std},ItalicFont={Adobe Kaiti Std}]{Adobe Song Std}
  \setCJKsansfont{Adobe Heiti Std}
  \setCJKmonofont{Adobe Kaiti Std}
  \setCJKfamilyfont{song}{Adobe Song Std}
  \setCJKfamilyfont{hei}{Adobe Heiti Std}
  \setCJKfamilyfont{fs}{Adobe Fangsong Std}
  \setCJKfamilyfont{kai}{Adobe Kaiti Std}
  \setCJKfamilyfont{li}{LiSu}      %%% 借用了ttf隶书
  \setCJKfamilyfont{you}{YouYuan}  %%% 借用了ttf幼圆
}
\setCJKfamilyfont{cusong}{STZhongsong}
\newcommand{\cusong}{\CJKfamily{cusong}} % 中宋作为加粗宋体
\ifisttf
  \installTTF
\else
  \installOTF
\fi
\newcommand{\song}{\CJKfamily{song}}    % 宋体
\newcommand{\fs}{\CJKfamily{fs}}        % 仿宋体
\newcommand{\kai}{\CJKfamily{kai}}      % 楷体
\newcommand{\hei}{\CJKfamily{hei}}      % 黑体
\newcommand{\li}{\CJKfamily{li}}        % 隶书
\newcommand{\you}{\CJKfamily{you}}      % 幼圆
\def\songti{\song}
\def\fangsong{\fs}
\def\kaishu{\kai}
\def\heiti{\hei}
\def\lishu{\li}
\def\youyuan{\you}
\newlength\thu@linespace
\newcommand{\thu@choosefont}[2]{%
    \setlength{\thu@linespace}{#2*\real{#1}}%
    \fontsize{#2}{\thu@linespace}\selectfont}
\def\thu@define@fontsize#1#2{%
    \expandafter\newcommand\csname #1\endcsname[1][\baselinestretch]{%
    \thu@choosefont{##1}{#2}}}
\thu@define@fontsize{chuhao}{42bp}
\thu@define@fontsize{xiaochu}{36bp}
\thu@define@fontsize{yihao}{26bp}
\thu@define@fontsize{xiaoyi}{24bp}
\thu@define@fontsize{erhao}{22bp}
\thu@define@fontsize{xiaoer}{18bp}
\thu@define@fontsize{sanhao}{16bp}
\thu@define@fontsize{xiaosan}{15bp}
\thu@define@fontsize{sihao}{14bp}
\thu@define@fontsize{banxiaosi}{13bp}
\thu@define@fontsize{xiaosi}{12bp}
\thu@define@fontsize{dawu}{11bp}
\thu@define@fontsize{wuhao}{10.5bp}
\thu@define@fontsize{xiaowu}{9bp}
\thu@define@fontsize{liuhao}{7.5bp}
\thu@define@fontsize{xiaoliu}{6.5bp}
\thu@define@fontsize{qihao}{5.5bp}
\thu@define@fontsize{bahao}{5bp}
\newcommand{\upcite}[1]{\textsuperscript{\cite{#1}}}                   %%% 上标形式引用
\newcommand{\china}{中华人民共和国}
\def\snnupaper{\textsc{Snnu}\textsc{Paper}}
\newcommand{\pozhehao}{\kern0.3ex\rule[0.8ex]{2em}{0.1ex}\kern0.3ex}   %%% 定义了破折号
\renewcommand\contentsname{目\hspace{2em}录}
\renewcommand\listfigurename{图\hspace{1em}目\hspace{1em}录}
\renewcommand\listtablename{表\hspace{1em}目\hspace{1em}录}
\newcommand\listequationname{公式索引}
\newcommand\equationname{公式}
\renewcommand\bibname{参考文献}
\renewcommand\indexname{索引}
\renewcommand\figurename{图}
\renewcommand\tablename{表}
\renewcommand\appendixname{附录}
\renewcommand{\thefigure}{\thechapter-\arabic{figure}}  %修改图标标题格式 2012.10.17 yinjc
\renewcommand{\thetable}{\thechapter-\arabic{table}}    %修改表标标题格式 2012.10.17 yinjc
\def\CJK@today{\CJKdigits{\the\year} 年 \CJKnumber{\the\month} 月  \CJKnumber{\the\day} 日}
\newcommand\zhtoday{\CJK@today}
\newcommand\entoday{\today{}}

%\let\MakeUppercase\relax              %%% 章节标题改成每个单词只有首字母大写,而其余字母小写 2011.05.25 yinjcx
%\let\MakeTextUppercase\relax          %%% 章节标题改成每个单词只有首字母大写,而其余字母小写

\geometry{top=36mm,bottom=25mm,left=30mm,right=30mm}
\geometry{headheight=9mm,headsep=1mm,footskip=10mm}
\renewcommand\setheadrule[1]{%
  \ifdim#1=\z@
    \let\makeheadrule\@empty
  \else
    \def\makeheadrule{%
    \makebox[0pt][l]{\rule[.1\baselineskip]{\linewidth}{3pt}}%
    \rule{\linewidth}{0.5pt}}%      %%% 设置页眉双线 2012.10.17 yinjc
  \fi}
\newpagestyle{myplain}{
\sethead[]
        [\raisebox{.65\baselineskip}{\songti \wuhao
           \ifisanon{~}\else{\the\university\@optionpaperclass{}学位论文}\fi}]
        []
        {}{\raisebox{.65\baselineskip}{\songti \wuhao 第 \thechapter 章\; \chaptertitle}}{}%
\setfoot{}{{\songti \wuhao - ~ \thepage ~ -}}{}%
\headrule%
%\footrule%                         %%% 取消注释设置页脚线 2011.05.21 yinjc
}
\setfootrule{1bp}
\newpagestyle{mybackplain}{
\sethead[]
        [\raisebox{.65\baselineskip}{\songti \wuhao
           \ifisanon{~}\else{\the\university\@optionpaperclass{}学位论文}\fi}]
        []
        {}{\raisebox{.65\baselineskip}{\songti \wuhao \chaptertitle}}{}%
\setfoot{}{{\songti \wuhao - ~ \thepage ~ -}}{}%
\headrule%
%\footrule%                         %%% 取消注释设置页脚线 2011.05.21 yinjc
}
\setfootrule{1bp}
\renewcommand\frontmatter{%
    \if@openright\cleardoublepage\else\clearpage\fi
    \@mainmatterfalse
    \pagenumbering{Roman}
    \pagestyle{plain}}
\newcommand\midmatter{%
    \if@openright\cleardoublepage\else\clearpage\fi
    \@mainmatterfalse
    \pagenumbering{roman}
    \pagestyle{plain}}
\renewcommand\mainmatter{%
    \if@openright\cleardoublepage\else\clearpage\fi
    \@mainmattertrue
    \pagenumbering{arabic}
    \pagestyle{myplain}
%    \titleformat{\chapter}{\heiti\sanhao[1.25]}{\qquad\thechapter\,}{1em}{}
    }
\renewcommand\backmatter{%
    \if@openright\cleardoublepage\else\clearpage\fi
    \titleformat{\chapter}{\filcenter \heiti \sanhao}{附录\,\thechapter\,}{1em}{}
    \titleformat{\backchapter}{\filcenter \heiti \sanhao}{}{1em}{}
    \titlecontents{chapter}[0pt]{\vspace{0.25\baselineskip} \heiti \xiaosi[1.25]}
      {附录\,\thecontentslabel\quad}{}
      {\hspace{.5em}\titlerule*{.}\contentspage}   %%%设置目录中附录与页码之间有点虚线 2011.05.21 yinjc
    \@mainmattertrue
    \pagestyle{mybackplain}}
\renewcommand\cleardoublepage
 {\clearpage\if@openright \ifodd\c@page\else
  \newpage{}
  \thispagestyle{empty}
  \vspace*{\fill}
  \begin{center}
  \end{center}
  \vspace*{\fill}
  \clearpage\fi\fi%
 }

%\renewcommand{\CJKunderlinecolor}{\color{black}}  %%% 更改下划线颜色为黑色，默认为蓝色 2011.05.22 yinjc
\renewcommand{\ULthickness}{0.8pt}                %%% 更改下划线粗细，默认为0.4pt

%%%=======================================定义目录的形式==================================================
\def\tableofcontents{%
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \else
      \@restonecolfalse
    \fi
    \chapter*{\thispagestyle{plain}%            !!!使得目录页不显示页眉，只显示页码 yinjc 2007-11-24
        \contentsname
        \@mkboth{%
           \MakeUppercase\contentsname}{\MakeUppercase\contentsname}}%
    \@starttoc{toc}%
    \if@restonecol\twocolumn\fi
    }
%%%========================================定义图目录的形式yinjc============================================
\def\listoffigures{%
    \@restonecolfalse
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \fi
    \chapter*{\thispagestyle{plain}%
        \listfigurename
        \@mkboth{
           \MakeUppercase\listfigurename}{\MakeUppercase\listfigurename}}
    \@starttoc{lof}
    \if@restonecol \twocolumn\fi
    }
\def\l@figure{\@dottedtocline{2}{1.5em}{2.3em}}
%%%========================================定义表目录的形式yinjc============================================
\def\listoftables{%
    \@restonecolfalse
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \fi
    \chapter*{\thispagestyle{plain}%
        \listtablename
        \@mkboth{
            \MakeUppercase\listtablename}{\MakeUppercase\listtablename}}
    \@starttoc{lot}
    \if@restonecol \twocolumn\fi
    }
\let\l@table\l@figure


\titlecontents{chapter}[0pt]{\vspace{0.25\baselineskip} \heiti \xiaosi[1.25]}
%    {第\CJKnumber{\thecontentslabel}章\quad}{}   %%%设置目录中章标题为第几章的格式
%   {\hspace{.5em}\titlerule*{}\contentspage}     %%%设置目录中章标题与页码之间的连线没有虚点线 2011.05.23 yinjc
    {第 \thecontentslabel 章\quad}{}
    {\hspace{.5em}\titlerule*{.}\contentspage}
\titlecontents{section}[1em]{\songti \xiaosi[1.25]}
    {\thecontentslabel\quad}{}
    {\hspace{.5em}\titlerule*{.}\contentspage}
\titlecontents{subsection}[2em]{\songti \xiaosi[1.25]}
    {\thecontentslabel\quad}{}
    {\hspace{.5em}\titlerule*{.}\contentspage}
\titlecontents{figure}[0pt]{\songti \xiaosi[1.25]}
    {\makebox[3.5em][l]{图~\thecontentslabel\quad}}{}
    {\hspace{.5em}\titlerule*{.}\contentspage}
\titlecontents{table}[0pt]{\songti \xiaosi[1.25]}
    {\makebox[3.5em][l]{表~\thecontentslabel\quad}}{}
    {\hspace{.5em}\titlerule*{.}\contentspage}
\renewcommand\chapter{\if@openright\cleardoublepage\else\clearpage\fi
                    \thispagestyle{myplain}%
                    \global\@topnum\z@
                    \@afterindentfalse
                    \secdef\snnu@chapter\@schapter}
\def\snnu@chapter[#1]#2{
  \ifnum \c@secnumdepth >\m@ne
    \if@openright\cleardoublepage\else\clearpage\fi
    \phantomsection
    \if@mainmatter
      \refstepcounter{chapter}%
      \addcontentsline{toc}{chapter}%
        {\protect\numberline{ \thechapter }#1}%
    \else
      \addcontentsline{toc}{chapter}{#1}%
    \fi
  \else
    \addcontentsline{toc}{chapter}{#1}%
  \fi
  \chaptermark{#1}%
  \if@twocolumn
    \@topnewpage[\@makechapterhead{#2}]%
  \else
    \@makechapterhead{#2}%
    \@afterheading
  \fi
}
\newcommand\cabstractname{摘要}
\newcommand\eabstractname{Abstract}
\newcommand\ckeywordsname{关键词}
\newcommand\ckeywords[1]{{\hei\xiaosi \ckeywordsname: #1}}
\newcommand\ekeywordsname{Key Words}
\newcommand\ekeywords[1]{\textsf{\xiaosi \ekeywordsname: #1}}
%\newenvironment{cabstract}{%
%    \chapter{\cabstractname}
%    \xiaosi
%    \@afterheading}
%    {\par\vspace{2em}\par}
%\newenvironment{eabstract}{%
%    \chapter{\textsf{\eabstractname}}
%    \xiaosi
%    \@afterheading}
%    {\par\vspace{2em}\par}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%==================摘要===========================================
\newenvironment{cabstract}{%
    \cleardoublepage \phantomsection
    \newpage%                                                   !!!解决了书签指向错误2007-12-15yinjc
%    \pagestyle{plain}%                                  !!!摘要页不显示页眉，只显示页码yinjc
    \chapter[\cabstractname]{\thispagestyle{plain}%
           \ziju{2em}{\cabstractname}}   %%%终于解决了书签乱码的问题 2005-04-12.huangzh

%     {\begin{center} {\heiti \xiaosan{\the\displaytitle}}\end{center}}\par
    \songti\xiaosi\setlength{\baselineskip}{20pt}
    {\song 正文：}
%    \addcontentsline{toc}{chapter}{摘要}
    \pagenumbering{Roman}%                               !!!设置摘要页的页码为大写罗马数字yinjc
    \@afterheading}
    {\par\vspace{0.5cm}}

%%==================英文摘要===========================================
\newenvironment{eabstract}{%
%    \cleardoublepage \phantomsection
%    \newpage%                                                   !!!解决了书签指向错误2007-12-15yinjc
%    \pagestyle{plain}%                                  !!!摘要页不显示页眉，只显示页码yinjc
    \chapter[\eabstractname]{\thispagestyle{plain}%
           {\eabstractname}}   %%%终于解决了书签乱码的问题 2005-04-12.huangzh
%
%    \cleardoublepage \phantomsection
%    \newpage
%%    \pagestyle{plain}%                                  !!!摘要页不显示页眉，只显示页码
%    \chapter{\thispagestyle{plain}\eabstractname}
%%    {\begin{center} {\bfseries \xiaosan {\@entitle}}\end{center}}\par
    \normalfont\large
    { Content：}
%    \addcontentsline{toc}{chapter}{Abstract}
    \@afterheading}
    {\par\vspace{0.5cm}}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\sectionbreak}{%
\addpenalty{-300}%
\vspace*{0pt}%
}
\setlength{\topskip}{0pt}
\setcounter{secnumdepth}{3}
%\titleformat{\chapter}{\filcenter \heiti\sanhao[1.25]}{第\CJKnumber{\thechapter}章\,}{1em}{}
%\titleformat{\section}{\filcenter \cusong\sihao[1.25]}{\thesection}{1em}{}
\titleformat{\chapter}{\filcenter\heiti\sanhao[1.25]}{第 {\thechapter} 章 \,}{1em}{}
\titleformat{\section}{\cusong\sihao[1.25]}{\thesection}{1em}{}
\titleformat{\subsection}{\heiti\xiaosi[1.25]}{\thesubsection}{1em}{}
\titleformat{\subsubsection}{\cusong\xiaosi[1.25]}{\thesubsubsection}{1em}{}
\titlespacing{\chapter}{0pt}{2.4ex-\topskip-\heightof{A}}{2.4ex}
\titlespacing{\section}{0pt}{2ex-\heightof{a}}{2ex}
\titlespacing{\subsection}{0pt}{2ex-\heightof{a}}{2ex}%{2em}{2ex}{2ex}
\titlespacing{\subsubsection}{2em}{1ex}{0ex}
\renewcommand\normalsize{%
\@setfontsize\normalsize{12bp}{12.87bp}%
\renewcommand{\baselinestretch}{1.3}%
\setlength\abovedisplayskip{10bp \@plus 2bp \@minus 2bp}%
\setlength\abovedisplayshortskip{10bp \@plus 2bp \@minus 2bp}%
\setlength\belowdisplayskip{\abovedisplayskip}%
\setlength\belowdisplayshortskip{\abovedisplayshortskip}%
}
\newlength\CJK@twochars
\def\CJK@spaceChar{\Unicode{48}{7}}
\def\CJKindent{%
  \settowidth\CJK@twochars{\CJK@spaceChar\CJK@spaceChar}%
  \parindent\CJK@twochars}
\AtBeginDocument{%
  \CJKindent\relax
  \checkparameter\relax
}
\setlength{\parskip}{0bp \@plus .5bp \@minus .5bp}
\newcommand*{\ziju}[1]{\renewcommand{\CJKglue}{\hskip #1}}
\renewenvironment{thebibliography}[1]{%
   \titleformat{\chapter}{\filcenter\heiti\sanhao[1.25]}{}{1em}{}
    \titlecontents{chapter}[0pt]{\vspace{0.25\baselineskip} \heiti \xiaosi[1.25]}
      {}{}
      {\hspace{.5em}\titlerule*{.}\contentspage}   %%%设置目录中附录与页码之间有点虚线 2011.05.21 yinjc
   \backchapter{\bibname}%
   \list{\@biblabel{\@arabic\c@enumiv}}%
        {\renewcommand{\makelabel}[1]{##1\hfill}
         \settowidth\labelwidth{1.1cm}
         \setlength{\labelsep}{0.4em}
         \setlength{\itemindent}{0pt}
         \setlength{\leftmargin}{\labelwidth+\labelsep}
         \addtolength{\itemsep}{-0.7em}
         \usecounter{enumiv}%
         \let\p@enumiv\@empty
         \renewcommand\theenumiv{\@arabic\c@enumiv}}%
    \sloppy\frenchspacing
    \clubpenalty4000%
    \@clubpenalty \clubpenalty
    \widowpenalty4000%
    \interlinepenalty4000%
    \sfcode`\.\@m}
   {\def\@noitemerr
     {\@latex@warning{Empty `thebibliography' environment}}%
    \endlist\frenchspacing}
\setlength{\floatsep}{12bp \@plus 2bp \@minus 1bp}
\setlength{\intextsep}{12bp \@plus 2bp \@minus 1bp}
\setlength{\textfloatsep}{12bp \@plus 2bp \@minus 1bp}
\setlength{\@fptop}{0bp \@plus1.0fil}
\setlength{\@fpsep}{12bp \@plus2.0fil}
\setlength{\@fpbot}{0bp \@plus1.0fil}
\renewcommand{\textfraction}{0.15}
\renewcommand{\topfraction}{0.85}
\renewcommand{\bottomfraction}{0.65}
\renewcommand{\floatpagefraction}{0.80}
\let\old@tabular\@tabular
\def\snnu@tabular{\wuhao[1.25]\old@tabular}
\DeclareCaptionLabelFormat{snnu}{{\wuhao[1.25]\song #1~\rmfamily #2}}
\DeclareCaptionLabelSeparator{snnu}{\hspace{1em}}
\DeclareCaptionFont{snnu}{\wuhao[1.25]}
\captionsetup{labelformat=snnu,labelsep=snnu,font=snnu}
\captionsetup[table]{position=top,belowskip={12bp-\intextsep},aboveskip=6bp}
\captionsetup[figure]{position=bottom,belowskip={9bp-\intextsep},aboveskip=6bp}
\captionsetup[subfloat]
{labelformat=simple,font=snnu,captionskip=6bp,nearskip=6bp,farskip=0bp,topadjust=0bp}
\renewcommand{\thesubfigure}{(\alph{subfigure})}
\renewcommand{\thesubtable}{(\alph{subtable})}
\let\snnu@LT@array\LT@array
\def\LT@array{\snnu@LT@array}

\newenvironment{denotation}[1][2.5cm]{
%    \chapter*{符号列表} % no tocline
    \cleardoublepage \phantomsection
%\newpage%                                                   !!!解决了书签指向错误2007-12-15yinjc
    \pagestyle{plain}
%    \newpage
    {\centerline{{\heiti\sanhao\ziju{1em}{符号列表}}}   }
    \noindent\begin{list}{}%
    {\vskip-30bp\xiaosi[1.6]
    \renewcommand\makelabel[1]{##1\hfil}
    \setlength{\labelwidth}{#1} % 标签盒子宽度
    \setlength{\labelsep}{0.5cm} % 标签与列表文本距离
    \setlength{\itemindent}{0cm} % 标签缩进量
    \setlength{\leftmargin}{\labelwidth+\labelsep} % 左边界
    \setlength{\rightmargin}{0cm}
    \setlength{\parsep}{0cm} % 段落间距
    \setlength{\itemsep}{0cm} % 标签间距
    \setlength{\listparindent}{0cm} % 段落缩进量
    \setlength{\topsep}{0pt} % 标签与上文的间距
}}{\end{list}}
\newcommand\backchapter{%                                     %%% 自定义附录后章的格式 2011.05.25 yinjc
     \if@openright\cleardoublepage\else\clearpage\fi
     \thispagestyle{mybackplain}%
     \global\@topnum\z@
     \@afterindentfalse
     \secdef\snnuback@chapter\@schapter}
\def\snnuback@chapter[#1]#2{
  \ifnum \c@secnumdepth >\m@ne
    \if@openright\cleardoublepage\else\clearpage\fi
    \phantomsection
    \if@mainmatter
      \refstepcounter{chapter}%
      \addcontentsline{toc}{chapter}%
        {\protect\numberline{ \thechapter }#1}%
    \else
      \addcontentsline{toc}{chapter}{#1}%
    \fi
  \else
    \addcontentsline{toc}{chapter}{#1}%
  \fi
  \chaptermark{#1}%
  \if@twocolumn
    \@topnewpage[\@makechapterhead{#2}]%
  \else
    \@makechapterhead{#2}%
    \@afterheading
  \fi
}
\newenvironment{ack}{%
    \if@openright\cleardoublepage\else\clearpage\fi
    \titleformat{\backchapter}{\filcenter\heiti\sanhao[1.25]\chaptertitle}{}{1em}{}
    \titleformat{\chapter}{\filcenter \heiti \sanhao}{}{1em}{}
    \titlecontents{chapter}[0pt]{\vspace{0.25\baselineskip} \heiti \xiaosi[1.25]}
      {}{}
      {\hspace{.5em}\titlerule*{.}\contentspage}   %%%设置目录中附录与页码之间有点虚线 2011.05.21 yinjc
    \backchapter{致谢}%
%    \addcontentsline{toc}{chapter}{致谢}%
    \ifisanon\color{white}\else\relax\fi%
    \xiaosi%
    \@afterheading
}
    {\par\vspace{2em}\par}

%\newenvironment{ack}{
%    \newpage
%    {\centerline{{\heiti\sanhao\ziju{2em}{致谢}}}   }
%    \songti\xiaosi
%    {\par\vspace*{5mm}}}

\newenvironment{resume}{%
    \if@openright\cleardoublepage\else\clearpage\fi
    \titleformat{\backchapter}{\filcenter\heiti\sanhao[1.25]}{}{1em}{}
    \titleformat{\chapter}{\filcenter \heiti \sanhao}{}{1em}{}
    \titlecontents{chapter}[0pt]{\vspace{0.25\baselineskip} \heiti \xiaosi[1.25]}
      {}{}
      {\hspace{.5em}\titlerule*{.}\contentspage}   %%%设置目录中附录与页码之间有点虚线 2011.05.21 yinjc
%    \titleformat{\chapter}{\filcenter\heiti\sanhao[1.25]}{\chaptertitle}{1em}{}
%    \titleformat{\section}{\filcenter\cusong\sihao[1.25]}{\thesection}{1em}{}
    \titleformat{\section}{\filcenter\cusong\sihao[1.25]}{\thesection}{1em}{}
    \backchapter{攻读\@optionpaperclass{}学位期间研究成果}
%    \addcontentsline{toc}{chapter}{攻读学位期间研究成果}
    \xiaosi
    \@afterheading}
    {\par\vspace{2em}\par}
\renewtheoremstyle{nonumberplain}%
{\item[\hspace*{2em} \theorem@headerfont ##1\ \theorem@separator]}%
{\item[\hspace*{2em} \theorem@headerfont ##1\ (##3)\theorem@separator]}
\theoremstyle{nonumberplain}
\theorembodyfont{\rmfamily}
\theoremheaderfont{\sffamily}
\theoremsymbol{\ensuremath{\blacksquare}}
\theoremseparator{:\,}
\newtheorem{proof}{证明}[chapter]
\newtheorem{assumption}{假设}[chapter]
\newtheorem{definition}{定义}[chapter]

\renewtheoremstyle{plain}%
{\item[\hspace*{2em} \theorem@headerfont ##1\ ##2\theorem@separator]}%
{\item[\hspace*{2em} \theorem@headerfont ##1\ ##2\ (##3)\theorem@separator]}
\theoremstyle{plain}
\theorembodyfont{\kai}
\theoremheaderfont{\hei}
\theoremsymbol{}
\newtheorem{lemma}{引理}[chapter]
\newtheorem{theorem}{定理}[chapter]
\newtheorem{axiom}{公理}[chapter]
\newtheorem{corollary}{推论}[chapter]
\newtheorem{conjecture}{猜想}[chapter]
\newtheorem{proposition}{命题}[chapter]
\newtheorem{exercise}{练习}[section]
\newtheorem{example}{例}[section]
\newtheorem{problem}{问题}[section]
\newtheorem{remark}{注释}[section]
\renewenvironment{split}{%
  \if@display%
    \ifinner%
      \@xp\@xp\@xp\split@aligned%
    \else%
      \ifst@rred \else \global\@eqnswtrue \fi%
    \fi%
  \fi%
  \collect@body\gather@split%
}{%
  \crcr%
  \egroup%
  \egroup%
  \iftagsleft@ \@xp\lendsplit@ \else \@xp\rendsplit@ \fi%
}
\def\classification#1{\def\@classification{#1}}   % 中图分类号
\def\serialno#1{\def\@serialno{#1}}               % 学号
\def\UDC#1{\def\@UDC{#1}}                         % UDC号
\def\confidentiality#1{\def\@confidentiality{#1}} % 密级
\def\title#1{\def\@title{#1}}                     % 中文题目
\newtoks\displaytitle
\newtoks\university                               % 学校名称
\newtoks\daima                                    % 学校代码
\newtoks\danwei                                   % 培养单位
\newtoks\cnName                                   % 中文姓名
\newtoks\subdate                                  % 提交论文时间
\def\author#1{\def\@author{#1}}
\def\zhdate#1{\def\@zhdate{#1}}                   % 中文日期
\def\subject#1{\def\@subject{#1}}                 % 中文学科
\def\subjectFirst#1{\def\@subjectFirst{#1}}       % 一级学科
\def\subjectSecond#1{\def\@subjectSecond{#1}}     % 二级学科
\def\researchfield#1{\def\@researchfield{#1}}     % 中文研究方向
\def\supervisor#1{\def\@supervisor{#1}}           % 导师
\def\cosupervisor#1{\def\@cosupervisor{#1}}       % 协助指导教师
\def\papertype#1{\def\@papertype{#1}}             % 工学，理学，以同等学历申请工(理)学
\def\entitle#1{\def\@entitle{#1}}
\def\enauthor#1{\def\@enauthor{#1}}
\def\ensupervisor#1{\def\@ensupervisor{#1}}
\def\encosupervisor#1{\def\@encosupervisor{#1}}
\def\endate#1{\def\@endate{#1}}
\def\ensubject#1{\def\@ensubject{#1}}
\def\enpapertype#1{\def\@enpapertype{#1}}               % Engineering, Science
\def\optionpaperclass#1{\def\@optionpaperclass{#1}}     % paperclass
\def\optionpaperclassen#1{\def\@optionpaperclassen{#1}} % paperclass english
\def\optionas#1{\def\@optionas{#1}}                     % Advisor OR Supervisor
\ifismaster
  \optionpaperclass{硕士}
  \optionpaperclassen{Master}
  \optionas{Advisor}
\else
  \optionpaperclass{博士}
  \optionpaperclassen{Doctor}
  \optionas{Supervisor}
\fi
\newcommand{\checkparameter}
{
  \ifthenelse{\isundefined{\@cosupervisor}}{\cosupervisor{}}{}
  \ifthenelse{\isundefined{\@encosupervisor}}{\encosupervisor{}}{}
}

%%========================================封面================================================================
\def\maketitle{%
  \null

  \ifisanon%
  \author{}%
  \enauthor{}%
  \supervisor{}%
  \cosupervisor{}%
  \ensupervisor{}%
  \encosupervisor{}%
  \university{\qquad\qquad\qquad}%
  \daima{}%
  \else\relax\fi%

\iffalse
  \pagestyle{empty}%
  \begin{center}
    \ifisanon{~}
      \else{\includegraphics[width=8.5cm]{figures/snnucn}\\
           \makebox[7.5cm][s]{\bf SHAANXI NORMAL UNIVERSITY}\\[1cm]}
    \fi
    {\songti \chuhao \makebox[7cm][s]{\@optionpaperclass{}学位论文}\\[2mm]
     {\large \@optionpaperclassen{} \ \ \ Dissertation }
    }
    \par
    \vspace{1cm}
    \begin{center} {\huge \@title \\[1mm]}\end{center}
     \vfill
    {\hei\xiaoer
     \begin{center}
       {
        {\makebox[3em][s]{作者} }{\songti\underline{\makebox[10em]{\qquad\@author\qquad }}} \\[3mm]
        {\makebox[3em][s]{导师} }{\songti \underline {\makebox[10em]{\qquad \@supervisor \qquad }}}\\[3mm]
        \ifx\@cosupervisor\@empty\else
          {\makebox[3em][s]{~} }{\songti\underline {\makebox[10em]{\@cosupervisor}}}\\[3mm]
        \fi
       }
       \par
       \vspace{1cm}
      {\heiti \sanhao \ifisanon{~}\else{\the\university}\fi}\\[3mm]
      {\heiti \sanhao \@zhdate \par}%
     \end{center}
    }
  \end{center}%
%  \null
%  \cleardoublepage

%%%%%%%%%%%英文封面%%%%%%%%%%%%%
  \newpage
  \thispagestyle{empty}%
  \begin{center}\leavevmode
  \vfill\bfseries
  {\erhao[1.25] \@entitle \par}
  {\sanhao[1.25]
  \vfill\vfill\vfill\vfill\vfill\vfill
  \begin{tabular}{rl}
    Candidate:\ & {\makebox[4.5cm][s]{\textsf{\@enauthor}}\hfill{}}\\
    \@optionas{}:\ & \textsf{\@ensupervisor}\\
    \ifx\@encosupervisor\@empty\else
      & \textsf{\@encosupervisor} \\
    \fi
  \end{tabular}}
  \vfill\vfill\vfill\vfill
  {\sanhao[1.5]
A dissertation\\
Submitted in partial fulfillment of the requirements\\
for the degree of \textsf{\@optionpaperclassen{} of \@enpapertype}\\
in \textsf{\@ensubject}\\
\makebox[\textwidth]{\ifisanon{~}\else{College of Mathematics and Information Science}\fi}\\
\ifisanon{~}\else{Shaanxi Normal University}\\ \fi
\ifisanon{~}\else{Xi'an, Shaanxi, P.\ R.\ China}\fi\\[5mm]
~\@endate~
  }
  \end{center}\vfill

\fi
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%========================================题名页================================================================
%  \cleardoublepage%
%  \newpage
  \thispagestyle{empty}
  \def\entry##1##2##3{%
    \multicolumn{##1}{l}{\underline{\hbox to ##2{\hfil##3\hfil}}}
    }
  \null
%  \ifisanon%
%  \author{}%
%  \enauthor{}%
%  \supervisor{}%
%  \cosupervisor{}%
%  \ensupervisor{}%
%  \encosupervisor{}%
%  \university{}%
%  \daima{}%
%  \else\relax\fi%
  \pagenumbering{alph}% not display, for print only
  \thispagestyle{empty}%

  {\kai \sihao \noindent%
    {\makebox[3em][s]{分类号}}{\songti\underline{\makebox[7em]{\@classification}}} \\
    {\makebox[3em][s]{密级} }{\songti \underline{\makebox[7em]{ \@confidentiality}}}\\
    {\makebox[3em][s]{学号} }{\songti\underline {\makebox[7em]{\@serialno}}}\\
  }
  \begin{center}\leavevmode % 表格环境
    \par
  \vspace*{1cm} %插入空白
    \ifisanon{\vspace{2.5cm}}
      \else{\includegraphics[width=8.5cm]{figures/snnucn}\\
           \makebox[7.5cm][s]{\bf SHAANXI NORMAL UNIVERSITY}\\[1cm]}
    \fi
    {\songti \yihao {\ziju{1em}\@optionpaperclass{}学位论文}%\\[2mm]
    }\\
%  {\heiti\sanhao \@papertype{}\@optionpaperclass{}学位论文}\\
  \vspace{50bp}\vfil
%  {\cusong\erhao[1.25]
%    \begin{tabular}{lp{12cm}}
%      \raisebox{-0.5ex}[0pt]{\makebox[1.8cm][r]{题\ 目}} &
%        \raisebox{-0.5ex}[0pt]{\songti \@title}\hfill{}\\ \cline{2-2}
%    \end{tabular}
%  \par}
  {\songti\erhao[1.25]
    \begin{tabular}{l>{\centering\arraybackslash}p{12cm}}
      \raisebox{0ex}[0pt]{\makebox[1.8cm][r]{\cusong\erhao[1.25]题\ 目}} &
        {\CJKunderline{\centering  \@title }} \\ %\cline{2-2}
    \end{tabular}
  \par}
  \vspace{100bp}
%  {\heiti \sihao
%    {\makebox[7em][s]{作者姓名} }{\songti\underline{\makebox[10em]{\qquad\@author\qquad }}} \\[3mm]
%    {\makebox[7em][s]{指导教师姓名} }{\songti \underline {\makebox[10em]{\qquad \@supervisor \qquad }}}\\[3mm]
%        \ifx\@cosupervisor\@empty\else
%          {\makebox[7em][s]{~} }{\songti\underline {\makebox[10em]{\@cosupervisor}}}\\[3mm]
%        \fi
%    {\makebox[7em][s]{学科专业} }{\songti\underline {\makebox[10em]{\@subject}}}\\[3mm]
%    {\makebox[7em][s]{提交论文时间} }{\songti\underline {\makebox[10em]{\the\subdate}}}\\
%  }
  {\heiti \sihao
    {\makebox[7em][s]{作者} }{\songti\underline{\makebox[15em]{\qquad\@author\qquad }}} \\[3mm]
    {\makebox[7em][s]{指导教师} }{\songti \underline {\makebox[15em]{\qquad \@supervisor \qquad }}}\\[3mm]
        \ifx\@cosupervisor\@empty\else
          {\makebox[7em][s]{~} }{\songti\underline {\makebox[15em]{\@cosupervisor}}}\\[3mm]
        \fi
    {\makebox[7em][s]{一级学科名称} }{\songti\underline {\makebox[15em]{\@subjectFirst}}}\\[3mm]
    {\makebox[7em][s]{二级学科名称} }{\songti\underline {\makebox[15em]{\@subjectSecond}}}\\[3mm]
    {\makebox[7em][s]{提交日期} }{\songti\underline {\makebox[15em]{\the\subdate}}}\\
  }
  \end{center}%
%%--------------------------------郑重申明-----------------------------------------%
%  \cleardoublepage%
  \newpage
  \thispagestyle{empty}
  \small\normalsize {
    \begin{center}{\song\xiaoer{学位论文原创性声明}}\end{center}\par}
  \renewcommand{\baselinestretch}{1.5}\normalsize
  {\song \xiaosi%

本人声明所呈交的学位论文是我在导师的指导下进行研究工作所取得的研究成果。
尽我所知，除文中已经注明引用的内容和致谢的地方外，本论文不包含其他个人或集体已经发表或撰写过的研究成果，
 也不包含本人或他人已申请学位或其他用途使用过的成果。
 对本文的研究做出重要贡献的个人和集体，均已在文中作了明确说明并表示谢意。

本学位论文若有不实或者侵犯他人权利的，本人愿意承担一切相关的法律责任。\\[1cm]

\hspace*{0.5cm}作者签名: \CJKunderline{\hspace{3cm}} \hfill
\hfill
日期:\ \ \ \ \ \ \ \  年 \ \ \ 月\  \ \ 日\hspace{1cm}\hfill\par}

\vspace{1.5cm}

\small\normalsize {
\begin{center}{\song\xiaoer{学位论文知识产权及使用授权声明书}}\end{center}\par}
\renewcommand{\baselinestretch}{1.5}\normalsize
{\song \xiaosi%

本人在导师指导下所完成的学位论文及相关成果，知识产权归属{\ifisanon{某某大学}\else{\the\university}\fi}。
本人完全了解{\ifisanon{某某大学}\else{\the\university}\fi}有关保存、使用学位论文的规定，允许本论文被查阅和借阅，
 学校有权保留学位论文并向国家有关部门或机构送交论文的纸质版和电子版，
 有权将本论文的全部或部分内容编入有关数据库进行检索，
 可以采用任何复制手段保存和汇编本论文。
本人保证毕业离校后，发表本论文或使用本论文成果时署名单位仍为{\ifisanon{某某大学}\else{\the\university}\fi}。

保密论文解密后适用本声明。\\[1cm]

\hspace*{0.5cm}作者签名: \CJKunderline{\hspace{3cm}} \hfill
\hfill
日期:\ \ \ \ \ \ \ \  年 \ \ \ 月\  \ \ 日\hspace{1cm}\hfill\par}
%%=========================================================================================

  \normalsize % normal, 正文开始
  \def\@tabular{\wuhao[1.25]\old@tabular} % 之后表格字体使用5号
  \cleardoublepage%
  \newpage
  \thispagestyle{empty}
} % QED
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%-----------索引( multicols 形式)----------
  \usepackage{makeidx}
  \newcommand{\URL}[1]{\href{#1}{\texttt{\itshape #1\/}}}
  \usepackage{multicol}
  \makeatletter
  \renewenvironment{theindex}
               {\let\chapternamesave\chaptername
        \renewcommand{\chaptername}{\hskip-1em}%
%        \def\chaptername{}\chapter[\indexname]{\ziju{2}\indexname} % 2005-06-15 huangzh
         \def\chaptername{}{\begin{center} {\heiti \sanhao\ziju{2pt}{\indexname}}\end{center}}%    !!!2007年11月7 日 yinjc
%         \addcontentsline{toc}{chapter}{\ziju{2pt}\indexname}%                            !!!2007 年11月7日 yinjc
         \addcontentsline{toc}{chapter}{索\qquad 引}%                            !!!2007年11月8日 yinjc
        %\addcontentsline{toc}{chapter}{\indexname}%   !!!
        \begin{multicols}{2}%[\chapter{\indexname}\vspace*{1cm}]
        \leftskip=2cm
                \markboth{\indexname}{\indexname}%
                \thispagestyle{plain}\parindent 0pt
                \parskip0pt plus .3pt\relax
                \let\item\@idxitem}
               {\end{multicols}\let\chaptername\chapternamesave}
  \makeatother
%--------------------------- 作者简介 -------------------------------
\newenvironment{zzjj}
   {
    \cleardoublepage \phantomsection
    \newpage \vspace*{5mm}
    {\centerline {\heiti\sanhao \ziju{1pt}{作者简介}}}\vspace*{8mm}
    \par\songti\normalsize
    \addcontentsline{toc}{chapter}{作者简介}
   }
    {\par\vspace*{5mm}}


%%------------------------------书脊---------------------------------
\newenvironment{shuji}
   {
    \newpage
    \thispagestyle{empty}
    \vspace*{5mm}
    \renewcommand{\baselinestretch}{1.2}
    \begin{center}
     \begin{minipage}{0.3cm}
       \heiti \large \ \
   }
    {\end{minipage}\end{center}}

\endinput
%%
%% End of file `snnupaper.cls'.
